using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record ResultSettings(string DateGroup,
                             int EpicYear,
                             string ModelName,
                             int NumberOfJitters,
                             int NumberOfTimesToUpsample,
                             string[] IgnoreExtensions,
                             string PredictorModelName,
                             int ResultAllInOneSubdirectoryLength,
                             string ResultCollection,
                             string ResultContent,
                             string ResultSingleton,
                             string RootDirectory,
                             string[] ValidImageFormatExtensions,
                             string[] ValidVideoFormatExtensions)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, ResultSettingsSourceGenerationContext.Default.ResultSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(ResultSettings))]
internal partial class ResultSettingsSourceGenerationContext : JsonSerializerContext
{
}